#include<reg167.h>
#include <stdio.h>

void main (void)
{
/* Set the serial port  */
  P3  |= 0x0400;
  DP3 |= 0x0400;              
  DP3 &= 0xF7FF;
  S0TIC = 0x80;
  S0RIC = 0x00;
  S0BG  = 0x40;
  S0CON = 0x8011;
/* ADC setup		    */
  ADCON |= 0x0011;     /*channel 1 continuous    */

/* Interrupt setup	    */
  ADCIC = 0x47;
  IEN = 1;

/* Start conversion     */
  ADST = 1;

  while(1);
}

static void ADC_isr (void) interrupt ADCINT = 40
{
  unsigned int adc_value;
  unsigned char adc_channel;

  adc_value = (ADDAT & 0x03FF);
  adc_channel = ADDAT >> 12;

  printf ("\rAnalog channel %bu = 0x%4.4X\r\n",adc_channel,adc_value);
}